unit AviUtlPlugin;
interface

{
  Automatically converted by H2Pas 1.0.0 from filter.h
  The following command line parameters were used:
    -s
    filter.h
}

uses
  Windows, Messages, UtilType;

type
{$IFDEF UNICODE}
  LPTSTR = PWideChar;
{$ELSE}
  LPTSTR = PChar;
{$ENDIF}

  HINSTANCE = DWORD;

  type
     PPIXEL_YC  = ^PIXEL_YC;
     PIXEL_YC = record
          y : smallint;
          cb : smallint;
          cr : smallint;
       end;

     PPIXEL  = ^PIXEL;
     PIXEL = record
          b : byte;
          g : byte;
          r : byte;
       end;

     PFILTER_PROC_INFO  = ^FILTER_PROC_INFO;
     FILTER_PROC_INFO = record
          flag : longint;
          ycp_edit : ^PIXEL_YC;
          ycp_temp : ^PIXEL_YC;
          w : longint;
          h : longint;
          max_w : longint;
          max_h : longint;
          frame : longint;
          frame_n : longint;
          org_w : longint;
          org_h : longint;
          audiop : ^smallint;
          audio_n : longint;
          audio_ch : longint;
          pixelp : ^PIXEL;
          editp : pointer;
          yc_size : longint;
          line_size : longint;
          reserve : array[0..7] of longint;
       end;

  const
     FILTER_PROC_INFO_FLAG_INVERT_FIELD_ORDER = $00010000;     
     FILTER_PROC_INFO_FLAG_INVERT_INTERLACE = $00020000;     

  type
     PFRAME_STATUS  = ^FRAME_STATUS;
     FRAME_STATUS = record
          video : longint;
          audio : longint;
          inter : longint;
          index24fps : longint;
          config : longint;
          vcm : longint;
          edit_flag : longint;
          reserve : array[0..8] of longint;
       end;

  const
     FRAME_STATUS_INTER_NORMAL = 0;     
     FRAME_STATUS_INTER_REVERSE = 1;     
     FRAME_STATUS_INTER_ODD = 2;     
     FRAME_STATUS_INTER_EVEN = 3;
     FRAME_STATUS_INTER_MIX = 4;
     FRAME_STATUS_INTER_AUTO = 5;
     EDIT_FRAME_EDIT_FLAG_KEYFRAME = 1;     
     EDIT_FRAME_EDIT_FLAG_MARKFRAME = 2;     
     EDIT_FRAME_EDIT_FLAG_DELFRAME = 4;     
     EDIT_FRAME_EDIT_FLAG_NULLFRAME = 8;     

  type
     PFILE_INFO  = ^FILE_INFO;
     FILE_INFO = record
          flag : longint;
          name : LPSTR;
          w : longint;
          h : longint;
          video_rate : longint;
          video_scale : longint;
          audio_rate : longint;
          audio_ch : longint;
          frame_n : longint;
          video_decode_format : DWORD;
          video_decode_bit : longint;
          audio_n : longint;
          reserve : array[0..3] of longint;
       end;

  const
     FILE_INFO_FLAG_VIDEO = 1;     
     FILE_INFO_FLAG_AUDIO = 2;     

  type
     PSYS_INFO  = ^SYS_INFO;
     SYS_INFO = record
          flag : longint;
          info : LPSTR;
          filter_n : longint;
          min_w : longint;
          min_h : longint;
          max_w : longint;
          max_h : longint;
          max_frame : longint;
          edit_name : LPSTR;
          project_name : LPSTR;
          output_name : LPSTR;
          vram_w : longint;
          vram_h : longint;
          vram_yc_size : longint;
          vram_line_size : longint;
          hfont : HFONT;
          build : longint;
          reserve : array[0..1] of longint;
       end;

  const
     SYS_INFO_FLAG_EDIT = 1;     
     SYS_INFO_FLAG_VFAPI = 2;     
     SYS_INFO_FLAG_USE_SSE = 4;     
     SYS_INFO_FLAG_USE_SSE2 = 8;     

  type

     MULTI_THREAD_FUNC = procedure (thread_id:longint; thread_num:longint; param1:pointer; param2:pointer);cdecl;

     AVI_FILE_HANDLE = pointer;

     EXFUNC = record
          get_ycp_ofs : procedure (editp:pointer; n:longint; ofs:longint);cdecl;
          get_ycp : function (editp:pointer; n:longint):pointer;cdecl;
          get_pixelp : function (editp:pointer; n:longint):pointer;cdecl;
          get_audio : function (editp:pointer; n:longint; buf:pointer):longint;cdecl;
          is_editing : function (editp:pointer):BOOL;cdecl;
          is_saving : function (editp:pointer):BOOL;cdecl;
          get_frame : function (editp:pointer):longint;cdecl;
          get_frame_n : function (editp:pointer):longint;cdecl;
          get_frame_size : function (editp:pointer; w:plongint; h:plongint):BOOL;cdecl;
          set_frame : function (editp:pointer; n:longint):longint;cdecl;
          set_frame_n : function (editp:pointer; n:longint):longint;cdecl;
          copy_frame : function (editp:pointer; d:longint; s:longint):BOOL;cdecl;
          copy_video : function (editp:pointer; d:longint; s:longint):BOOL;cdecl;
          copy_audio : function (editp:pointer; d:longint; s:longint):BOOL;cdecl;
          copy_clip : function (hwnd:HWND; pixelp:pointer; w:longint; h:longint):BOOL;cdecl;
          paste_clip : function (hwnd:HWND; editp:pointer; n:longint):BOOL;cdecl;
          get_frame_status : function (editp:pointer; n:longint; fsp:pFRAME_STATUS):BOOL;cdecl;
          set_frame_status : function (editp:pointer; n:longint; fsp:pFRAME_STATUS):BOOL;cdecl;
          is_saveframe : function (editp:pointer; n:longint):BOOL;cdecl;
          is_keyframe : function (editp:pointer; n:longint):BOOL;cdecl;
          is_recompress : function (editp:pointer; n:longint):BOOL;cdecl;
          filter_window_update : function (fp:pointer):BOOL;cdecl;
          is_filter_window_disp : function (fp:pointer):BOOL;cdecl;
          get_file_info : function (editp:pointer; fip:pFILE_INFO):BOOL;cdecl;
          get_config_name : function (editp:pointer; n:longint):LPSTR;cdecl;
          is_filter_active : function (fp:pointer):BOOL;cdecl;
          get_pixel_filtered : function (editp:pointer; n:longint; pixelp:pointer; w:plongint; h:plongint):BOOL;cdecl;
          get_audio_filtered : function (editp:pointer; n:longint; buf:pointer):longint;cdecl;
          get_select_frame : function (editp:pointer; s:plongint; e:plongint):BOOL;cdecl;
          set_select_frame : function (editp:pointer; s:longint; e:longint):BOOL;cdecl;
          rgb2yc : function (ycp:pPIXEL_YC; pixelp:pPIXEL; w:longint):BOOL;cdecl;
          yc2rgb : function (pixelp:pPIXEL; ycp:pPIXEL_YC; w:longint):BOOL;cdecl;
          dlg_get_load_name : function (name:LPSTR; filter:LPSTR; def:LPSTR):BOOL;cdecl;
          dlg_get_save_name : function (name:LPSTR; filter:LPSTR; def:LPSTR):BOOL;cdecl;
          ini_load_int : function (fp:pointer; key:LPSTR; n:longint):longint;cdecl;
          ini_save_int : function (fp:pointer; key:LPSTR; n:longint):longint;cdecl;
          ini_load_str : function (fp:pointer; key:LPSTR; str:LPSTR; def:LPSTR):BOOL;cdecl;
          ini_save_str : function (fp:pointer; key:LPSTR; str:LPSTR):BOOL;cdecl;
          get_source_file_info : function (editp:pointer; fip:pFILE_INFO; source_file_id:longint):BOOL;cdecl;
          get_source_video_number : function (editp:pointer; n:longint; source_file_id:plongint; source_video_number:plongint):BOOL;cdecl;
          get_sys_info : function (editp:pointer; sip:pSYS_INFO):BOOL;cdecl;
          get_filterp : function (filter_id:longint):pointer;cdecl;
          get_ycp_filtering : function (fp:pointer; editp:pointer; n:longint; reserve:pointer):pointer;cdecl;
          get_audio_filtering : function (fp:pointer; editp:pointer; n:longint; buf:pointer):longint;cdecl;
          set_ycp_filtering_cache_size : function (fp:pointer; w:longint; h:longint; d:longint; flag:longint):BOOL;cdecl;
          get_ycp_filtering_cache : function (fp:pointer; editp:pointer; n:longint):pointer;cdecl;
          get_ycp_source_cache : function (editp:pointer; n:longint; ofs:longint):pointer;cdecl;
          get_disp_pixelp : function (editp:pointer; format:DWORD):pointer;cdecl;
          get_pixel_source : function (editp:pointer; n:longint; pixelp:pointer; format:DWORD):BOOL;cdecl;
          get_pixel_filtered_ex : function (editp:pointer; n:longint; pixelp:pointer; w:plongint; h:plongint;
                       format:DWORD):BOOL;cdecl;
          get_ycp_filtering_cache_ex : function (fp:pointer; editp:pointer; n:longint; w:plongint; h:plongint):PPIXEL_YC;cdecl;
          exec_multi_thread_func : function (func:MULTI_THREAD_FUNC; param1:pointer; param2:pointer):BOOL;cdecl;
          create_yc : function :PPIXEL_YC;cdecl;
          delete_yc : procedure (ycp:pPIXEL_YC);cdecl;
          load_image : function (ycp:pPIXEL_YC; _file:LPSTR; w:plongint; h:plongint; flag:longint):BOOL;cdecl;
          resize_yc : procedure (ycp:pPIXEL_YC; w:longint; h:longint; ycp_src:pPIXEL_YC; sx:longint;
                        sy:longint; sw:longint; sh:longint);cdecl;
          copy_yc : procedure (ycp:pPIXEL_YC; x:longint; y:longint; ycp_src:pPIXEL_YC; sx:longint;
                        sy:longint; sw:longint; sh:longint; tr:longint);cdecl;
          draw_text : procedure (ycp:pPIXEL_YC; x:longint; y:longint; text:LPSTR; r:longint;
                        g:longint; b:longint; tr:longint; hfont:HFONT; w:plongint;
                        h:plongint);cdecl;
          avi_file_open : function (_file:LPSTR; fip:pFILE_INFO; flag:longint):AVI_FILE_HANDLE;cdecl;
          avi_file_close : procedure (afh:AVI_FILE_HANDLE);cdecl;
          avi_file_read_video : function (afh:AVI_FILE_HANDLE; ycp:pPIXEL_YC; n:longint):BOOL;cdecl;
          avi_file_read_audio : function (afh:AVI_FILE_HANDLE; buf:pointer; n:longint):longint;cdecl;
          avi_file_get_video_pixelp : function (afh:AVI_FILE_HANDLE; n:longint):pointer;cdecl;
          get_avi_file_filter : function (_type:longint):LPSTR;cdecl;
          avi_file_read_audio_sample : function (afh:AVI_FILE_HANDLE; start:longint; length:longint; buf:pointer):longint;cdecl;
          avi_file_set_audio_sample_rate : function (afh:AVI_FILE_HANDLE; audio_rate:longint; audio_ch:longint):longint;cdecl;
          reserve : array[0..13] of longint;
       end;

  const
     AVI_FILE_OPEN_FLAG_VIDEO_ONLY = 16;     
     AVI_FILE_OPEN_FLAG_AUDIO_ONLY = 32;     
     AVI_FILE_OPEN_FLAG_ONLY_YUY2 = $10000;     
     AVI_FILE_OPEN_FLAG_ONLY_RGB24 = $20000;     
     AVI_FILE_OPEN_FLAG_ONLY_RGB32 = $40000;
     GET_AVI_FILE_FILTER_TYPE_VIDEO = 0;
     GET_AVI_FILE_FILTER_TYPE_AUDIO = 1;     

  type
     PFILTER  = ^FILTER;
     FILTER = record
          flag : longint;
          x : longint;
          y : longint;
          name : LPTSTR;
          track_n : longint;
          track_name : ^LPTSTR;
          track_default : ^longint;
          track_s : ^longint;
          track_e : ^longint;
          check_n : longint;
          check_name : ^LPTSTR;
          check_default : ^longint;
          func_proc : function (fp:pointer; fpip:pFILTER_PROC_INFO):BOOL;cdecl;
          func_init : function (fp:pointer):BOOL;cdecl;
          func_exit : function (fp:pointer):BOOL;cdecl;
          func_update : function (fp:pointer; status:longint):BOOL;cdecl;
          func_WndProc : function (hwnd:HWND; message:UINT; wparam:WPARAM; lparam:LPARAM; editp:pointer; 
                       fp:pointer):BOOL;cdecl;
          track : PIntArray;
          check : PIntArray;
          ex_data_ptr : pointer;
          ex_data_size : longint;
          information : LPTSTR;
          func_save_start : function (fp:pointer; s:longint; e:longint; editp:pointer):BOOL;cdecl;
          func_save_end : function (fp:pointer; editp:pointer):BOOL;cdecl;
          exfunc : ^EXFUNC;
          hwnd : HWND;
          dll_hinst : HINSTANCE;
          ex_data_def : pointer;
          func_is_saveframe : function (fp:pointer; editp:pointer; saveno:longint; frame:longint; fps:longint; 
                       edit_flag:longint; inter:longint):BOOL;cdecl;
          func_project_load : function (fp:pointer; editp:pointer; data:pointer; size:longint):BOOL;cdecl;
          func_project_save : function (fp:pointer; editp:pointer; data:pointer; size:plongint):BOOL;cdecl;
          func_modify_title : function (fp:pointer; editp:pointer; frame:longint; title:LPSTR; max_title:longint):BOOL;cdecl;
          dll_path : LPTSTR;
          reserve : array[0..1] of longint;
       end;

  const
     FILTER_FLAG_ACTIVE = 1;     
     FILTER_FLAG_ALWAYS_ACTIVE = 4;     
     FILTER_FLAG_CONFIG_POPUP = 8;     
     FILTER_FLAG_CONFIG_CHECK = 16;     
     FILTER_FLAG_CONFIG_RADIO = 32;     
     FILTER_FLAG_EX_DATA = 1024;     
     FILTER_FLAG_PRIORITY_HIGHEST = 2048;     
     FILTER_FLAG_PRIORITY_LOWEST = 4096;     
     FILTER_FLAG_WINDOW_THICKFRAME = 8192;     
     FILTER_FLAG_WINDOW_SIZE = 16384;     
     FILTER_FLAG_DISP_FILTER = 32768;     
     FILTER_FLAG_REDRAW = $20000;     
     FILTER_FLAG_EX_INFORMATION = $40000;     
     FILTER_FLAG_INFORMATION = $80000;
     FILTER_FLAG_NO_CONFIG = $100000;
     FILTER_FLAG_AUDIO_FILTER = $200000;     
     FILTER_FLAG_RADIO_BUTTON = $400000;     
     FILTER_FLAG_WINDOW_HSCROLL = $800000;     
     FILTER_FLAG_WINDOW_VSCROLL = $1000000;     
     FILTER_FLAG_INTERLACE_FILTER = $4000000;     
     FILTER_FLAG_NO_INIT_DATA = $8000000;     
     FILTER_FLAG_IMPORT = $10000000;     
     FILTER_FLAG_EXPORT = $20000000;     
     FILTER_FLAG_MAIN_MESSAGE = $40000000;     
     WM_FILTER_UPDATE = WM_USER+100;
     WM_FILTER_FILE_OPEN = WM_USER+101;     
     WM_FILTER_FILE_CLOSE = WM_USER+102;     
     WM_FILTER_INIT = WM_USER+103;     
     WM_FILTER_EXIT = WM_USER+104;     
     WM_FILTER_SAVE_START = WM_USER+105;     
     WM_FILTER_SAVE_END = WM_USER+106;     
     WM_FILTER_IMPORT = WM_USER+107;     
     WM_FILTER_EXPORT = WM_USER+108;     
     WM_FILTER_CHANGE_ACTIVE = WM_USER+109;     
     WM_FILTER_CHANGE_WINDOW = WM_USER+110;     
     WM_FILTER_CHANGE_PARAM = WM_USER+111;     
     WM_FILTER_CHANGE_EDIT = WM_USER+112;     
     WM_FILTER_MAIN_MOUSE_DOWN = WM_USER+120;     
     WM_FILTER_MAIN_MOUSE_UP = WM_USER+121;     
     WM_FILTER_MAIN_MOUSE_MOVE = WM_USER+122;     
     WM_FILTER_MAIN_KEY_DOWN = WM_USER+123;     
     WM_FILTER_MAIN_KEY_UP = WM_USER+124;     
     WM_FILTER_MAIN_MOVESIZE = WM_USER+125;     
     WM_FILTER_MAIN_MOUSE_DBLCLK = WM_USER+126;     
     FILTER_UPDATE_STATUS_ALL = 0;     
     FILTER_UPDATE_STATUS_TRACK = $10000;     
     FILTER_UPDATE_STATUS_CHECK = $20000;     
     FILTER_WINDOW_SIZE_CLIENT = $10000000;
     FILTER_WINDOW_SIZE_ADD = $30000000;

  type
     PFILTER_DLL = ^FILTER_DLL;
     FILTER_DLL = record
          flag : longint;
          x : longint;
          y : longint;
          name : LPTSTR;
          track_n : longint;
          track_name : ^LPTSTR;
          track_default : ^longint;
          track_s : ^longint;
          track_e : ^longint;
          check_n : longint;
          check_name : ^LPTSTR;
          check_default : ^longint;
          func_proc : function (fp:pFILTER; fpip:pFILTER_PROC_INFO):BOOL;cdecl;
          func_init : function (fp:pFILTER):BOOL;cdecl;
          func_exit : function (fp:pFILTER):BOOL;cdecl;
          func_update : function (fp:pFILTER; status:longint):BOOL;cdecl;
          func_WndProc : function (hwnd:HWND; message:UINT; wparam:WPARAM; lparam:LPARAM; editp:pointer; 
                       fp:pFILTER):BOOL;cdecl;
          track : PIntArray;
          check : PIntArray;
          ex_data_ptr : pointer;
          ex_data_size : longint;
          information : LPTSTR;
          func_save_start : function (fp:pFILTER; s:longint; e:longint; editp:pointer):BOOL;cdecl;
          func_save_end : function (fp:pFILTER; editp:pointer):BOOL;cdecl;
          exfunc : ^EXFUNC;
          hwnd : HWND;
          dll_hinst : HINSTANCE;
          ex_data_def : pointer;
          func_is_saveframe : function (fp:pFILTER; editp:pointer; saveno:longint; frame:longint; fps:longint;
                       edit_flag:longint; inter:longint):BOOL;cdecl;
          func_project_load : function (fp:pFILTER; editp:pointer; data:pointer; size:longint):BOOL;cdecl;
          func_project_save : function (fp:pFILTER; editp:pointer; data:pointer; size:plongint):BOOL;cdecl;
          func_modify_title : function (fp:pFILTER; editp:pointer; frame:longint; title:LPSTR; max_title:longint):BOOL;cdecl;
          dll_path : LPTSTR;
          reserve : array[0..1] of longint;
       end;

  const
     MID_FILTER_BUTTON = 12004;     
(*
  function func_proc(fp:pFILTER; fpip:pFILTER_PROC_INFO):BOOL;

  function func_init(fp:pFILTER):BOOL;

  function func_exit(fp:pFILTER):BOOL;

  function func_update(fp:pFILTER; status:longint):BOOL;

  function func_WndProc(hwnd:HWND; message:UINT; wparam:WPARAM; lparam:LPARAM; editp:pointer; 
             fp:pFILTER):BOOL;

  function func_save_start(fp:pFILTER; s:longint; e:longint; editp:pointer):BOOL;

  function func_save_end(fp:pFILTER; editp:pointer):BOOL;

  function func_is_saveframe(fp:pFILTER; editp:pointer; saveno:longint; frame:longint; fps:longint; 
             edit_flag:longint; inter:longint):BOOL;

  function func_project_load(fp:pFILTER; editp:pointer; data:pointer; size:longint):BOOL;

  function func_project_save(fp:pFILTER; editp:pointer; data:pointer; size:plongint):BOOL;

  function func_modify_title(fp:pFILTER; editp:pointer; frame:longint; title:LPSTR; max_title:longint):BOOL;
*)

implementation
(*
  function func_proc(fp:pFILTER; fpip:pFILTER_PROC_INFO):BOOL;
  begin
    { You must implement this function }
  end;
  function func_init(fp:pFILTER):BOOL;
  begin
    { You must implement this function }
  end;
  function func_exit(fp:pFILTER):BOOL;
  begin
    { You must implement this function }
  end;
  function func_update(fp:pFILTER; status:longint):BOOL;
  begin
    { You must implement this function }
  end;
  function func_WndProc(hwnd:HWND; message:UINT; wparam:WPARAM; lparam:LPARAM; editp:pointer; 
             fp:pFILTER):BOOL;
  begin
    { You must implement this function }
  end;
  function func_save_start(fp:pFILTER; s:longint; e:longint; editp:pointer):BOOL;
  begin
    { You must implement this function }
  end;
  function func_save_end(fp:pFILTER; editp:pointer):BOOL;
  begin
    { You must implement this function }
  end;
  function func_is_saveframe(fp:pFILTER; editp:pointer; saveno:longint; frame:longint; fps:longint; 
             edit_flag:longint; inter:longint):BOOL;
  begin
    { You must implement this function }
  end;
  function func_project_load(fp:pFILTER; editp:pointer; data:pointer; size:longint):BOOL;
  begin
    { You must implement this function }
  end;
  function func_project_save(fp:pFILTER; editp:pointer; data:pointer; size:plongint):BOOL;
  begin
    { You must implement this function }
  end;
  function func_modify_title(fp:pFILTER; editp:pointer; frame:longint; title:LPSTR; max_title:longint):BOOL;
  begin
    { You must implement this function }
  end;
*)

end.
